class SS{
	public static int aux(int[] t, int j, boolean enCours){
		//0 <= j < t.length
		//spec : voir sujet

		if(j==t.length-1){
			return t[j]; //que enCours soit vrai ou pas, pas le choix car la séquence doit être non vide
		}
		else{
			if(enCours){
				return Math.max(t[j],t[j]+aux(t,j+1,enCours));
			}
			else{
				//soit on prend et enCours devient true, soit pas
				return Math.max(aux(t,j,true),aux(t,j+1,false));
			}
		}
	}

	public static int auxDP(int[] t, int j, boolean enCours, int[][]tabMarq){
		//tabMarqu[j][b] -infini si pas déjà calcule
		//pour 0 <= j < t.length et 0<=b<=1 (b==0 pour enCours faux)

		int b=enCours?1:0;
		if(tabMarq[j][b]==Integer.MIN_VALUE){
			int res;
			if(j==t.length-1){
				res = t[j]; //que enCours soit vrai ou pas, pas le choix
			}
			else{
				if(enCours){
					res = Math.max(t[j],t[j]+aux(t,j+1,enCours));
				}
				else{
					//soit on prend et enCours devient true, soit pas
					res = Math.max(aux(t,j,true),aux(t,j+1,false));
				}
			}
			tabMarq[j][b]=res;
		}
		return tabMarq[j][b];

	}

	public static int ssConseq(int[]t){
		int[][] tabMarq = new int[t.length][2];
		for(int j=0;j<t.length;j++){
			for(int b=0;b<2;b++){
				tabMarq[j][b]=Integer.MIN_VALUE;
			}
		}
		return auxDP(t,0,false,tabMarq);
	}

	public static void main(String[]args){
		int[]t0 = {3, -4, 5, -1, 3, -2, -3, 6, -10, 4, 2};
		System.out.println(ssConseq(t0));
		int[]t = {-2, 8, -1, 6, -3, 9, 4, -1};
		System.out.println(aux(t,2,true));
		System.out.println(ssConseq(t));
	}

}
